#include <stdio.h>
#include <sys/fcntl.h>

#define SETALLOWED 0x43505500
#define GETALLOWED 0x43505501

int main(int argc, char ** argv)
{
  int fd=open("/dev/cpus_allowed",O_RDONLY);
  if (fd==-1) {
    perror("/dev/cpus_allowed");
    exit(1);
  }
  switch (argc) {
  case 1:
    {
      long mask=0;
      if(ioctl(fd,GETALLOWED,&mask)) {
	perror("GETALLOWED");
	exit(1);
      }
      printf("%08X\n",mask);
    }
    break;
  case 0:
  case 2:
    printf("Usage: %s\n"
	   "       %s <mask> <cmdline>\n",argv[0],argv[0]);
    break;
  default:
    if(ioctl(fd,SETALLOWED,atoi(argv[1]))) {
      perror("SETALLOWED");
      exit(1);
    }
    execvp(argv[2],argv+2);
    perror(argv[2]);
    exit(1);
  }
}
